{
Problem: Bridges-hills
Solution author: Gleb Grenkin
}

{$APPTYPE CONSOLE}
{$Q+,R+}

program bridges;
uses
  Math;
const
  maxN = 1000;
type
  TIsland = record
    x, y: integer;
    c: boolean;
    num: integer;
  end;
var
  a: array[1..2*maxN] of TIsland;
  n: integer;
  i: integer;

  procedure SwapIslands(var a, b: TIsland);
  var
    tmp: TIsland;
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

  procedure Solve(l, r: integer);
  var
    b: array[boolean] of integer;
    mi: integer;
    x: integer;
    i: integer;

    function CrossProduct(x1, y1, x2, y2: Int64): Int64;
    begin
      Result := x1*y2 - x2*y1;
    end;

    function Lower(p, q: TIsland): boolean;
    begin
      Result := CrossProduct(p.x-a[r].x, p.y-a[r].y, q.x-a[r].x, q.y-a[r].y) > 0;
    end;

    procedure QSort(l, r: integer);
    var
      i, j: integer;
      x: TIsland;
    begin
      if (l >= r) then
        Exit;
      i := l; j := r; x := a[(l+r) div 2];
      repeat
        while Lower(a[i], x) do inc(i);
        while Lower(x, a[j]) do dec(j);
        if (i <= j) then
        begin
          SwapIslands(a[i], a[j]);
          inc(i); dec(j);
        end;
      until (i > j);
      QSort(l, j); QSort(i, r);
    end;

  begin
    assert(l <> r);
    if (l > r) then
      Exit;
    mi := l;
    for i := l to r do
    begin
      if (a[i].x < a[mi].x) or (a[i].x = a[mi].x) and (a[i].y < a[mi].y) then
        mi := i;
    end;
    SwapIslands(a[r], a[mi]);
    QSort(l, r-1);
    if (a[l].c <> a[r].c) then
      x := l
    else if (a[r-1].c <> a[r].c) then
      x := r-1
    else
    begin
      b[false] := 0; b[true] := 0;
      x := 0;
      for i := l to r-1 do
      begin
        if (b[false] = b[true]) and (a[i].c <> a[r].c) then
        begin
          x := i;
          break;
        end;
        inc(b[a[i].c]);
      end;
      assert(x <> 0);
    end;
    if not a[r].c then
      writeln(a[r].num, ' ', a[x].num)
    else
      writeln(a[x].num, ' ', a[r].num);
    for i := x to r-2 do
      a[i] := a[i+1];
    Solve(l, x-1);
    Solve(x, r-2);
  end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  read(n);
  for i := 1 to n do
  begin
    read(a[i].x, a[i].y);
    a[i].c := false;
    a[i].num := i;
  end;
  for i := 1 to n do
  begin
    read(a[n+i].x, a[n+i].y);
    a[n+i].c := true;
    a[n+i].num := i;
  end;

  Solve(1, 2*n);

  close(input);
  close(output);
end.
