{
Checker for the problem "Bridges-hill"
Code author: Gleb Grenkin
}

{
  !
     checker'   ,  
    CheckLines -  ,    ,
      .
       
    ,  -  (    )
     Solution accepted.
}

{$APPTYPE CONSOLE}
{$Q+,R+}

program bridges_checker;
uses
  SysUtils, Math;
const
  minX = -100000;
  maxX = 100000;
  minY = -100000;
  maxY = 100000;
  maxN = 1000;
type
  TIsland = record
    x, y: integer;
    c: boolean;
    num: integer;
  end;
var
  a, aa: array[1..2*maxN] of TIsland;
  bx, by, sx, sy: array[1..maxN] of integer;
  bp, sp: array[1..maxN] of integer;
  bu, su: array[1..maxN] of boolean;
  n: integer;
  i, j: integer;
  fin, fout: text;

  procedure Ex(const s: string; ec: integer);
  begin
    write(s);
    try
      close(fin); close(fout);
    except
    end;
    halt(ec);
  end;

  procedure SwapIslands(var a, b: TIsland);
  var
    tmp: TIsland;
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

  function OnTheSameLine(a, b, c: TIsland): boolean;
  var
    x1, y1, x2, y2, x3, y3: Int64;
  begin
    x1 := a.x; y1 := a.y;
    x2 := b.x; y2 := b.y;
    x3 := c.x; y3 := c.y;
    Result := (x3-x1)*(y2-y1) = (x2-x1)*(y3-y1);
  end;

  procedure CheckLines;
  var
    i, j: integer;

    function Angle(p: TIsland): extended;
    begin
      if (p.x = a[j].x) and (p.y = a[j].y) then
        Result := 1e100
      else
      begin
        Result := ArcTan2(p.y-a[j].y, p.x-a[j].x);
        if (Result < -pi/2) then
          Result := Result + pi;
        if (Result > pi/2) then
          Result := Result - pi;
        if (abs(Result + pi/2) <= 1e-6) then
          Result := pi/2;
      end;
    end;

    procedure QSort(l, r: integer);
    var
      i, j: integer;
      x: TIsland;
    begin
      if (l >= r) then
        Exit;
      i := l; j := r; x := aa[(l+r) div 2];
      repeat
        while (Angle(aa[i]) < Angle(x)) do inc(i);
        while (Angle(x) < Angle(aa[j])) do dec(j);
        if (i <= j) then
        begin
          SwapIslands(aa[i], aa[j]);
          inc(i); dec(j);
        end;
      until (i > j);
      QSort(l, j); QSort(i, r);
    end;

  begin
    aa := a;
    for j := 1 to 2*n do
    begin
      QSort(1, 2*n);
      for i := 2 to 2*n-1 do
      begin
        if OnTheSameLine(aa[i], aa[i-1], a[j]) then
          Ex('Bad input file!!! Points: ' +
           '(num = ' + IntToStr(aa[i].num) + ', type = ' + IntToStr(ord(aa[i].c)) + ') ' +
           '(num = ' + IntToStr(aa[i-1].num) + ', type = ' + IntToStr(ord(aa[i-1].c)) + ') ' +
           '(num = ' + IntToStr(a[j].num) + ', type = ' + IntToStr(ord(a[j].c)) + ') ' +
           'are on the same line', 3);
      end;
      a := aa;
    end;
  end;

  function sign(x: Int64): integer;
  begin
    if (x = 0) then
      Result := 0
    else if (x > 0) then
      Result := 1
    else
      Result := -1;
  end;

  function CrossProduct(x1, y1, x2, y2: Int64): Int64;
  begin
    Result := x1*y2 - x2*y1;
  end;

  function IntersectedIntervals(x1, y1, x2, y2, x3, y3, x4, y4: integer): boolean;
  begin
    Result := (sign(CrossProduct(x2-x1, y2-y1, x3-x1, y3-y1))*
               sign(CrossProduct(x2-x1, y2-y1, x4-x1, y4-y1)) < 0) and
              (sign(CrossProduct(x4-x3, y4-y3, x1-x3, y1-y3))*
               sign(CrossProduct(x4-x3, y4-y3, x2-x3, y2-y3)) < 0);
  end;

  function IntersectedBridges(bnum1, snum1, bnum2, snum2: integer): boolean;
  begin
    Result := IntersectedIntervals(bx[bnum1], by[bnum1], sx[snum1], sy[snum1],
                                   bx[bnum2], by[bnum2], sx[snum2], sy[snum2]);
  end;

begin
  try
    assign(fin, ParamStr(1)); reset(fin);
  except on e: Exception do
    Ex('Error opening input: ' + e.Message, 3);
  end;
  if SeekEof(fin) then
    Ex('The input file is empty', 3);
  read(fin, n);
  if not((n >= 1) and (n <= maxN)) then
    Ex('Bad value N: not in range 1..maxN', 3);
  for i := 1 to n do
  begin
    read(fin, a[i].x, a[i].y);
    if not ((a[i].x >= minX) and (a[i].x <= maxX)) then
      Ex('Bad value X[' + IntToStr(i) + ']', 3);
    if not ((a[i].y >= minY) and (a[i].y <= maxY)) then
      Ex('Bad value Y[' + IntToStr(i) + ']', 3);
    bx[i] := a[i].x; by[i] := a[i].y;
    a[i].c := false;
    a[i].num := i;
  end;
  for i := 1 to n do
  begin
    read(fin, a[n+i].x, a[n+i].y);
    if not ((a[n+i].x >= minX) and (a[n+i].x <= maxX)) then
      Ex('Bad value x[' + IntToStr(i) + ']', 3);
    if not ((a[n+i].y >= minY) and (a[n+i].y <= maxY)) then
      Ex('Bad value y[' + IntToStr(i) + ']', 3);
    sx[i] := a[n+i].x; sy[i] := a[n+i].y;
    a[n+i].c := true;
    a[n+i].num := i;
  end;
  if not SeekEof(fin) then
    Ex('Extra input data', 3);

  ////////////////////////////////////////////
  // .  
  //CheckLines; 2007.11.13
  ////////////////////////////////////////////


  try
    assign(fout, ParamStr(2)); reset(fout);
  except on e: Exception do
    Ex('Can''t open output: ' + e.Message, 2);
  end;
  if SeekEof(fout) then
    Ex('Empty output file', 2);
  try
    read(fout, bp[1]);
  except
    Ex('The first line in the output is bad', 2);
  end;
  if (bp[1] = -1) then
    Ex('Output: -1', 1);
  try
    read(fout, sp[1]);
  except
    Ex('The first line in the output is bad', 2);
  end;
  for i := 2 to n do
  begin
    if SeekEof(fout) then
      Ex('Unexpected end of the output: only ' + IntToStr(i-1) + 'lines are correct', 2);
    try
      read(fout, bp[i], sp[i]);
    except
      Ex('Bad line #' + IntToStr(i), 2);
    end;
  end;
  if not SeekEof(fout) then
    Ex('Extra lines in the output', 2);

  FillChar(bu, SizeOf(bu), 0);
  FillChar(su, SizeOf(su), 0);
  for i := 1 to n do
  begin
    if not ((bp[i] >= 1) and (bp[i] <= n) and (sp[i] >= 1) and (sp[i] <= n)) then
      Ex('Bad line #' + IntToStr(i) + ': bad island index', 1);
    if bu[bp[i]] then
      Ex('Repeated big island #' + IntToStr(bp[i]) + ' at the line #' + IntToStr(i), 1);
    if su[sp[i]] then
      Ex('Repeated small island #' + IntToStr(sp[i]) + ' at the line #' + IntToStr(i), 1);
    bu[bp[i]] := true; su[sp[i]] := true;
  end;

  for i := 1 to n do
  begin
    for j := i+1 to n do
    begin
      if IntersectedBridges(bp[i], sp[i], bp[j], sp[j]) then
        Ex('Intersecting bridges:' +
         '(big #' + IntToStr(bp[i]) + ' to small #' + IntToStr(sp[i]) + ') and ' +
         '(big #' + IntToStr(bp[j]) + ' to small #' + IntToStr(sp[j]) + ')', 1);
    end;
  end;
  Ex('OK', 0);
end.