{
Tests generator for the problem "Bridges-hills"
Source author: Gleb Grenkin

Call syntax: gen.exe <RandSeed> <N> [<minX> <minY> <maxX> <maxY>]
}

{$APPTYPE CONSOLE}
{$Q+,R+}

program gen_bridge;
uses
  SysUtils, Math;
var
  x, y, xx, yy: array[1..2000] of integer;
  n: integer;
  minX, maxX, minY, maxY: integer;
  nx, ny: integer;  
  i: integer;

  procedure swapint(var a, b: integer);
  var
    tmp: integer;
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

  function OnTheSameLine(x1, y1, x2, y2, x3, y3: Int64): boolean;
  begin
    Result := (x3-x1)*(y2-y1) = (x2-x1)*(y3-y1);
  end;

  function IsLine(n: integer; px, py: integer): boolean;
  var
    i: integer;

    function Angle(x, y: integer): extended;
    begin
      Result := ArcTan2(y-py, x-px);
      if (Result < -pi/2) then
        Result := Result + pi;
      if (Result > pi/2) then
        Result := Result - pi;
      if (abs(Result + pi/2) <= 1e-6) then
        Result := pi/2;
    end;

    procedure QSort(l, r: integer);
    var
      i, j: integer;
      x, y: integer;
    begin
      if (l >= r) then
        Exit;
      i := l; j := r; x := xx[(l+r) div 2]; y := yy[(l+r) div 2];
      repeat
        while (Angle(xx[i], yy[i]) < Angle(x, y)) do inc(i);
        while (Angle(x, y) < Angle(xx[j], yy[j])) do dec(j);
        if (i <= j) then
        begin
          swapint(xx[i], xx[j]);
          swapint(yy[i], yy[j]);
          inc(i); dec(j);
        end;
      until (i > j);
      QSort(l, j); QSort(i, r);
    end;

  begin
    Result := false;
    for i := 1 to n do
    begin
      if (x[i] = px) and (y[i] = py) then
      begin
        Result := true;
        Exit;
      end;
    end;
    xx := x; yy := y;
    QSort(1, n);
    for i := 2 to n do
    begin
      if OnTheSameLine(xx[i], yy[i], xx[i-1], yy[i-1], px, py) then
      begin
        Result := true;
        Exit;
      end;
    end;
  end;

begin
  RandSeed := StrToInt(ParamStr(1));
  n := StrToInt(ParamStr(2));
  n := 2*n;
  if (ParamCount = 2) then
  begin
    minX := -100000;
    maxX := 100000;
    minY := -100000;
    maxY := 100000;
  end
  else
  begin
    minX := StrToInt(ParamStr(3));
    minY := StrToInt(ParamStr(4));
    maxX := StrToInt(ParamStr(5));
    maxY := StrToInt(ParamStr(6));
  end;
  for i := 1 to n do
  begin
    repeat
      nx := minX + random(maxX-minX+1);
      ny := minX + random(maxY-minY+1);
    until not IsLine(i-1, nx, ny);
    x[i] := nx; y[i] := ny;
  end;

  assign(output, 'input.txt');
  rewrite(output);
  writeln(n div 2);
  for i := 1 to n do
  begin
    write(x[i], ' ', y[i]);
    if (i < n) then
      writeln;
  end;
  close(output);
end.