#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <assert.h>

using namespace std;

struct THill{
  double x, y;
  int num, type;
  bool operator < (const THill &a){
    return x < a.x || (x == a.x && y < a.y);
  }

  friend istream &operator >> (istream &input_stream, THill &a){
    input_stream >> a.x >> a.y;
    return input_stream;
  }
};

const int MaxN = 2001;
THill bridge[MaxN];
THill rp;
int check[2];

inline bool THill_angle_less(THill &a, THill &b){
  return (a.y - rp.y)/(a.x - rp.x) < (b.y - rp.y)/(b.x - rp.x);
}

inline int get_left_bottom_bridge_number(int &l, int &r){
  int result = r;
  for(int i = l; i < r; i++){
    if(bridge[i] < bridge[result]){
      result = i;
    }
  }
  return result;
}

inline void sort(int &l, int &r){
  swap(bridge[r], bridge[get_left_bottom_bridge_number(l, r)]);
  rp = bridge[r];
  sort(bridge+l, bridge+r, THill_angle_less);
}

inline void write(int l, int r){
  assert(bridge[l].type != bridge[r].type);
  if(bridge[l].type == 0){
    cout << bridge[l].num << " " << bridge[r].num;
  }else{
    cout << bridge[r].num << " " << bridge[l].num;
  }
  cout << endl;
}

void rec(int l, int r){
  if(l >= r) return;
  int i = r-1;
  sort(l, r);
  if(bridge[r].type != bridge[r-1].type){
    write(r, r-1);
    rec(l, r-2);
  }else{
    check[0] = check[1] = 0;
    do{
      check[bridge[i--].type]++;
    }while(check[0] != check[1] || bridge[r].type == bridge[i].type);
    write(i, r);
    rec(l, i-1);
    rec(i+1, r-1);
  }
}

int i, n;

int main(){ 
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  cin >> n;
  for(i = 1; i <= n; i++){
    cin >> bridge[i]; bridge[i].type = 0; bridge[i].num = i;
  }
  for(i = 1; i <= n; i++){
    cin >> bridge[n+i]; bridge[n+i].type = 1; bridge[n+i].num = i;
  }
  rec(1, 2*n);
  fclose(stdin);
  fclose(stdout);
  return 0;
}